export * as Api from "./Api.js";

// --- EXPERIMENTS -------------------------------------------------------------

import * as Api from "./Api.js";
import * as S from "@effect/schema/Schema";

const Id = S.struct({ _id: S.ULID });

const Product = S.struct({
	name: S.string,
	price: S.bigint,
});

const WithId = S.extend(Id);

const LoginRequest = S.struct({
	username: S.string,
	password: S.string,
});

const login = Api.make({
	method: "POST",
	route: ["login"],
	requestBody: LoginRequest,
});

const logout = Api.make({
	method: "POST",
	route: ["logout"],
});

const getProducts = Api.make({
	method: "GET",
	route: ["products"],
	responseBody: S.array(WithId(Product)),
});

const getProduct = Api.make({
	method: "GET",
	route: ["products", ["_id", S.ULID]],
	responseBody: WithId(Product),
});

const postProduct = Api.make({
	method: "POST",
	route: ["products"],
	requestBody: Product, responseBody: Id,
});

const putProduct = Api.make({
	method: "PUT",
	route: ["products", ["_id", S.ULID]],
	requestBody: Product,
});

const patchProduct = Api.make({
	method: "PATCH",
	route: ["products", ["_id", S.ULID]],
	requestBody: S.partial(Product),
});

const deleteProduct = Api.make({
	method: "POST",
	route: ["products", ["_id", S.ULID]],
});
